package function.builtin;

import function.LispFunction;
import sexpression.*;

public class PLUS extends LispFunction {

    public LispNumber call(Cons argList) {
        if (argList.nullp()) {
            return new LispNumber(0);
        }

        if (!argList.getCdr().listp())
            throw new RuntimeException("+: " + argList + " is dotted");

        SExpression argFirst = argList.getCar();
        Cons argRest = (Cons) argList.getCdr();

        if (argFirst.numberp()) {
            LispNumber num1 = (LispNumber) argFirst;
            LispNumber num2 = call(argRest);

            return new LispNumber(num1.getValue() + num2.getValue());
        }

        throw new RuntimeException("+: " + argFirst + " is not a number");
    }

}
